'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ExtendableError = function (_Error) {
  _inherits(ExtendableError, _Error);

  function ExtendableError(message) {
    _classCallCheck(this, ExtendableError);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(ExtendableError).call(this, message));

    _this.message = message;
    _this.name = _this.constructor.name;

    _this.stack = new Error(message).stack;
    return _this;
  }

  return ExtendableError;
}(Error);

/**
 * An error which gets thrown when an attempt is made to register a database
 * object multiple times.
 * @extends Error
 * @property {string} name Name of the database object in question.
 */


var DbObjectAlreadyRegisteredError = exports.DbObjectAlreadyRegisteredError = function (_ExtendableError) {
  _inherits(DbObjectAlreadyRegisteredError, _ExtendableError);

  function DbObjectAlreadyRegisteredError(name) {
    _classCallCheck(this, DbObjectAlreadyRegisteredError);

    var _this2 = _possibleConstructorReturn(this, Object.getPrototypeOf(DbObjectAlreadyRegisteredError).call(this, 'Database object with name \'' + name + '\' cannot be registered multiple times'));

    _this2.name = name;
    return _this2;
  }

  return DbObjectAlreadyRegisteredError;
}(ExtendableError);

/**
 * An error which gets thrown when an attempt is made to store an empty database
 * object.
 * @extends Error
 */


var EmptyDbObjectError = exports.EmptyDbObjectError = function (_ExtendableError2) {
  _inherits(EmptyDbObjectError, _ExtendableError2);

  function EmptyDbObjectError() {
    _classCallCheck(this, EmptyDbObjectError);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(EmptyDbObjectError).call(this, 'Empty database object cannot be stored'));
  }

  return EmptyDbObjectError;
}(ExtendableError);

/**
 * An error which gets thrown when an attempt is made to modify an inexistent
 * database object.
 * @extends Error
 */


var InexistentDbObjectError = exports.InexistentDbObjectError = function (_ExtendableError3) {
  _inherits(InexistentDbObjectError, _ExtendableError3);

  function InexistentDbObjectError() {
    _classCallCheck(this, InexistentDbObjectError);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(InexistentDbObjectError).call(this, 'Database object does not exist'));
  }

  return InexistentDbObjectError;
}(ExtendableError);

/**
 * An error which gets thrown when a Relation does not behave as expected.
 * @extends Error
 */


var RelationError = exports.RelationError = function (_ExtendableError4) {
  _inherits(RelationError, _ExtendableError4);

  function RelationError() {
    _classCallCheck(this, RelationError);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(RelationError).call(this, 'One-to-one and many-to-one Relations cannot be re-assigned'));
  }

  return RelationError;
}(ExtendableError);
//# sourceMappingURL=errors.js.map