'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

exports.camelizeKeys = camelizeKeys;
exports.flattenArray = flattenArray;
exports.modelize = modelize;
exports.requireUncached = requireUncached;

var _inflection = require('inflection');

function camelizeKeys(obj) {
  // Support recursive array transformation
  if (Array.isArray(obj)) {
    return obj.map(function (item) {
      return camelizeKeys(item);
    });
  }

  var result = {};
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = Object.entries(obj)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var _step$value = _slicedToArray(_step.value, 2);

      var key = _step$value[0];
      var value = _step$value[1];

      result[(0, _inflection.camelize)(key, true)] = value;
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  return result;
}

function flattenArray(value) {
  return [].concat.apply([], value);
}

function modelize(obj, Model) {
  // Support recursive array transformation
  if (Array.isArray(obj)) {
    return obj.map(function (item) {
      return modelize(item, Model);
    });
  }

  // Don't modelize non-objects
  return obj instanceof Object ? new Model(obj, false) : obj;
}

function requireUncached(modulePath) {
  delete require.cache[require.resolve(modulePath)];
  return require(modulePath).default;
}
//# sourceMappingURL=utils.js.map